/* HiAnalyzer */

#import <Cocoa/Cocoa.h>
#import <AudioToolbox/AudioToolbox.h>

#define SAMPLE_BACK_COLOR   blackColor
#define SAMPLE_DATA_COLOR  cyanColor
#define SAMPLE_SCALE_COLOR  whiteColor
#define SAMPLE_UNSELECT_COLOR   blackColor
#define SAMPLE_PRESENT_COLOR redColor
#define SAMPLE_OMMIT_INTERVAL	8

extern NSString *KEY_IMAGEFILE;
extern NSString *CreateImageFileNotification;

@class HiControler;

@interface HiAnalyzer : NSObject

{
	HiControler	*controler;
	
	NSMutableArray	*creatingImageList;
	NSImage			*saveImage;	//消去された部分の画像
	int				savePoint;	//消去された部分の位置
}

- (void)awakeFromNib;
//- (void)dealloc;

+ (BOOL)soundFileExistAtPath:(NSString *)path;
+ (BOOL)imageFileExistAtPath:(NSString *)path;
- (void)createImageFileWithSoundFile:(NSString *)filePath;
+ (NSString *)deleteImageFile:(NSString *)filePath;
- (void)createImageFileThread:(NSString *)filePath;		//直接呼び出してはいけない
- (NSImage *)imageWithSoundFile:(NSString *)filePath;
- (void)removeCreatingImageList:(NSString *)filePath;
- (BOOL)isCreatingImageFile:(NSString *)filePath;
- (void)drawPositionLine:(int)inPosition;
- (void)erasePositionLine;
- (int)pointAtPosition:(long)inPosition;
- (int)savePoint;
- (void)initPositionLine;

@end
