/* HiControler */

#import <Cocoa/Cocoa.h>

enum {
	Index_RecordTab		= 0,
	Index_PlayTab		= 1,
	Index_ReserveTab	= 2,
	Index_KeepTab		= 3
};

#define Width_Recorder	352.0
#define Height_Recorder	240.0
#define Width_Player	510.0
#define Height_Player	296.0
#define Width_Reserver	706.0
#define Height_Reserver	296.0
#define Width_Keeper	376.0
//#define Width_Keeper	352.0
#define Height_Keeper	296.0
#define DEF_AUTHORIZATION	NO
#define DEF_WINDOWOPACITY	1.0

extern NSString *KEY_AUTHORIZATION;
extern NSString *KEY_WINDOWOPACITY;

@class HiPrefer;
@class HiPlayer;
@class HiRecorder;
@class HiMechanic;
@class HiPlayList;
@class HiAnalyzer;
@class HiReserver;
@class HiLevelMeter;
@class HiReserveList;
@class HiDutyLog;
@class HiDevice;
@class HiKeeper;
@class HiTableView;

@interface HiControler : NSObject
{
	//インターフェースビルダー
	NSWindow		*mainWindow;
	HiPrefer		*prefer;
	HiPlayer		*player;
	HiRecorder		*recorder;
	HiMechanic		*mechanic;
	HiAnalyzer		*analyzer;
	HiReserver		*reserver;
	HiReserveList	*reservelist;
	HiLevelMeter	*meter;
	HiDutyLog		*dutylog;
	HiDevice		*devicer;
	HiKeeper		*keeper;
	HiTableView		*recordTable;
	HiTableView		*keepTable;
	NSTabView		*mainTab;
	NSButton		*authorizationButton;

	BOOL			authorization;
	float			opacity;
}

//********************
// 初期化
//********************

- (void)saveUserDefaults;

//- (BOOL)checkMTCoreAudio;

//********************
// アクセッサ
//********************

- (HiPrefer *)prefer;
- (HiPlayer *)player;
- (HiRecorder *)recorder;
- (HiMechanic *)mechanic;
- (HiAnalyzer *)analyzer;
- (HiLevelMeter *)meter;
- (HiReserver *)reserver;
- (HiDutyLog *)dutylog;
- (HiDevice *)devicer;
- (BOOL)authorization;
- (float)opacity;
- (void)setOpacity:(float)opacity;

//********************
// アクション
//********************

- (void)actAuthorization:(id)sender;
- (IBAction)actVersionButton:(id)sender;
- (IBAction)actCopyrightButton:(id)sender;

- (void)dataKeepCompletedHandler:(NSNotification *)note;

@end
