/* HiKeepList */

#import <Cocoa/Cocoa.h>

@class HiKeeper;
@class HiPlayList;

@interface HiKeepList : NSObject
{
	HiKeeper		*keeper;
	HiPlayList		*playlist;
	
	NSMutableArray	*keepList;
	NSMutableArray	*fileList;
}

//********************
// 初期化等
//********************

- (id)initWithDirPath:(NSString *)inDirPath;

//********************
// ユーティリティ
//********************

- (int)totalFiles;
- (NSString *)totalPeriodString;
- (double)totalSize;
- (double)fileSizeAtRow:(int)inRow;
- (double)totalTime;
- (double)spendTimeAtRow:(int)inRow;
- (NSString *)spendTimeStringAtRow:(int)inRow;
- (NSString *)fileNameAtRow:(int)inIndex;

//********************
// tableViewに必要なメソッド
//********************

- (id)tableView:(NSTableView *)aTableView
		objectValueForTableColumn:(NSTableColumn *)aTableColumn
		row:(int)rowIndex;


- (void)tableView:(NSTableView *)aTableView
		setObjectValue:anObject
		forTableColumn:(NSTableColumn *)aTableColumn
		row:(int)rowIndex;

- (int)numberOfRowsInTableView:(NSTableView *)aTableView;

//**************************
// ドラッグ＆ドロップに必要なメソッド
//**************************

- (BOOL)tableView:(NSTableView *)aTableView
		writeRows:(NSArray *)rows
	 toPasteboard:(NSPasteboard *)pboard;

@end
