/* HiLevelMeter */

#import <Cocoa/Cocoa.h>
#import "MTCoreAudio.h"
#import <AudioToolbox/AudioToolbox.h>

#define MAX_INPUTLEVEL		100.0
#define LEVEL_LEDS			20
#define NORMAL_LEVEL		17
#define LEVEL_INTERVAL		0.05	//レベルメータを表示する間隔
#define LEVEL_INTERVAL_COUNT	8	//レベルを計測する間隔

#define DEF_PEEKHOLDTIME	1.0		//瞬間最大値を表示する時間
	
extern NSString *KEY_PEEKHOLDTIME;

@class HiControler;
@class HiRecorder;

@interface HiLevelMeter : NSObject
{
	//
	HiControler	*controler;
	HiRecorder *recorder;
	
	//各ＬＥＤのイメージ
	NSImageView *led00;
	NSImageView *led01;
	NSImageView *led02;
	NSImageView *led03;
	NSImageView *led04;
	NSImageView *led05;
	NSImageView *led06;
	NSImageView *led07;
	NSImageView *led08;
	NSImageView *led09;
	NSImageView *led10;
	NSImageView *led11;
	NSImageView *led12;
	NSImageView *led13;
	NSImageView *led14;
	NSImageView *led15;
	NSImageView *led16;
	NSImageView *led17;
	NSImageView *led18;
	NSImageView *led19;
	
	//オーディオデバイス関係
//	MTCoreAudioDevice	*leveInputDevice;		//LED用デバイス
	int		counter;	//内部使用、入力信号カウンタ
	Float32	*buffer;	//内部使用、入力信号バッファ
	UInt32	frames;		//内部使用、入力信号のフレーム数
	
	//
	NSMutableArray	*ledArray;	//レベル表示用LEDの配列

	int		lastNum;		//前回点灯したＬＥＤ番号+1(０は何も点灯していない)
	int		maxNum;			//瞬間最大値
	int		maxCount;		//瞬間最大値表示時間カウンタ
	int		level;			//入力レベルの平均値
	double	peekHoldTime;	//瞬間最大値表示時間
	
	//ＬＥＤのＯＮ，ＯＦＦイメージ
	NSImage *onImage;
	NSImage *offImage;
	NSImage *redOnImage;
	NSImage *redOffImage;
	
	//レベル表示用タイマ
	NSTimer *timer;
}

//- (void)awakeFromNib;
- (void)saveUserDefaults;
- (void)setLevelIOTargetWithDevice:(MTCoreAudioDevice *)device;	//レベル表示対象のデバイスを設定する

//アクセッサ
- (int)level;							//現在のレベル平均値を得る
- (double)peekHoldTime;					//瞬間最大値表示時間を得る
- (void)setPeekHoldTime:(double)inTime;	//瞬間最大値表示時間の設定

//内部使用メソッド
- (OSStatus)levelInputIOForDevice:(MTCoreAudioDevice *)theDevice 
					   timeStamp:(const AudioTimeStamp *)inNow 
					   inputData:(const AudioBufferList *)inInputData 
					   inputTime:(const AudioTimeStamp *)inInputTime 
					  outputData:(AudioBufferList *)outOutputData 
					  outputTime:(const AudioTimeStamp *)inOutputTime 
					  clientData:(void *)inClientData;
- (void)execLevelMeter:(NSTimer *)aTimer;	//タイマーで動くレベル表示
- (void)levelAnalyzer;	//レベル値解析と表示
- (void)dispLevel:(int)inLevel;	//レベル値を表示する
- (void)initLEDDisplay;			//ＬＥＤディスプレイの初期化
- (void)renewLEDDisplay;

@end
