/* HiPlayList */

#import <Cocoa/Cocoa.h>

@class HiControler;
@class HiMechanic;

@interface HiPlayList : NSObject
{
	HiControler		*controler;
	NSMutableArray	*playList;
	NSMutableArray	*fileList;
	HiMechanic		*mechanic;
}

//********************
// 初期化等
//********************

- (id)initWithDirPath:(NSString *)inDirPath;

//********************
// アクセッサ
//********************

- (NSString *)fileNameAtRow:(int)inIndex;
- (double)fileSizeAtRow:(int)inRow;
- (double)spendTimeAtRow:(int)inRow;
- (NSString *)startTimeStringAtRow:(int)inRow;
- (NSString *)endTimeStringAtRow:(int)inRow;
- (NSString *)spendTimeStringAtRow:(int)inRow;
- (NSString *)noteStringAtRow:(int)inRow;

//********************
// ユーティリティ
//********************

- (BOOL)isLockedAtRow:(int)inRow;
- (NSString *)totalPeriodString;
- (double)totalTimeExceptLocked;
- (double)totalTime;
- (double)totalSize;
- (int)totalFiles;
- (NSString *)periodStringWithHour:(int)hour minute:(int)minute second:(int)second;
- (NSString *)periodStringWithHour:(int)hour minute:(int)minute second:(int)second milisec:(int)mili;
- (NSString *)timeStringWithHour:(int)hour minute:(int)minute second:(int)second;
- (NSString *)timeStringWithHour:(int)hour minute:(int)minute second:(int)second milisec:(int)mili;
- (NSString *)periodStringWithSeconds:(double)seconds;
- (NSString *)timeStringWithSeconds:(double)seconds;
- (NSString *)periodStringWithMiliSeconds:(double)milisec;
- (NSString *)timeStringWithMiliSeconds:(double)milisec;
- (double)secondsWithSpendString:(NSString *)inString;
- (double)secondsWithTimeString:(NSString *)inString;
- (NSString *)numberStringWithHour:(int)hour minute:(int)minute second:(int)second;
- (NSString *)numberStringWithSeconds:(double)inSeconds;

//********************
// tableViewに必要なメソッド
//********************

- (id)tableView:(NSTableView *)aTableView
		objectValueForTableColumn:(NSTableColumn *)aTableColumn
		row:(int)rowIndex;


- (void)tableView:(NSTableView *)aTableView
		setObjectValue:anObject
		forTableColumn:(NSTableColumn *)aTableColumn
		row:(int)rowIndex;

- (int)numberOfRowsInTableView:(NSTableView *)aTableView;

//**************************
// ドラッグ＆ドロップに必要なメソッド
//**************************

- (BOOL)tableView:(NSTableView *)aTableView
		writeRows:(NSArray *)rows
	 toPasteboard:(NSPasteboard *)pboard;

@end
