//
//  HiQueBuffer.h
//  HiSoudDuty
//
//  Created by kuikui on 05/05/30.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "MTCoreAudio.h"
#import <AudioToolbox/AudioToolbox.h>

@interface HiQueBuffer : NSObject {
	UInt8	*queBuffer;	//バッファの先頭位置
	UInt32	queLength;	//バッファの大きさ（バイト）
	
	UInt32	getPoint;	//読み出し位置
	UInt32	putPoint;	//書き込み位置
	UInt32	remain;		//キューに入っているデータの数（バイト）
}

//イニシャライザ
- (id)initQueWithLength:(UInt32)inLength;

//パブリックメソッド
- (UInt32)readFloat32Data:(Float32 *)outData length:(UInt32)inLength;
- (UInt32)writeFloat32Data:(Float32 *)inData length:(UInt32)inLength;
//- (UInt32)clearDataWithLeftLength:(UInt32)inLength;
- (UInt32)clearDataWithLeftLengthFloat32:(UInt32)inLength;
- (UInt32)empty;
- (UInt32)queLength;
- (id)setQueLength:(UInt32)length;
- (void)clearData;
- (UInt32)remain;

//内部使用メソッド
- (void)incPutFloat32Point:(UInt32 *)inPoint;
- (void)incGetFloat32Point:(UInt32 *)inPoint;

@end
