/* HiWaveView */

#import <Cocoa/Cocoa.h>

enum {
	Direction_Non	= 0,
	Direction_Right	= 1,
	Direction_Left	= 2
};

#define SAMPLE_SELECT_COLOR magentaColor
#define KEY_SELECTEDRANGE	@"SelectedRange"

extern	NSString *SelectRangeStartNotification;
extern	NSString *SelectRangeDragNotification;
extern	NSString *SelectRangeEndNotification;
extern	NSString *SelectRangeReleaseNotification;

@interface HiWaveView : NSImageView
{
	NSRange	selectedRange;
	
	NSImage *copyImage;
	int	startPoint;
	int	lastPoint;
	int	lastDirection;
	BOOL	dragging;
	BOOL	selectEnabled;
	BOOL	shiftKey;
}

- (NSRange)selectedRange;
- (void)setSelectedRange:(NSRange)inRange;
- (void)clearSelectedRange;
- (void)extendRight;
- (void)extendLeft;
- (void)reduceRight;
- (void)reduceLeft;
- (void)markSelectedRange:(NSRange)inRange;
- (void)releaseSelectedRange:(NSRange)inRange;
- (void)releaseLastSelect;
- (NSRange)rangeFrom:(int)inFrom to:(int)inTo;
- (void)setSelectEnabled:(BOOL)inBool;

@end
